package org.openxma.dsl.generator.mojo;

import java.io.UnsupportedEncodingException;

import org.eclipse.xtext.mwe.Reader;
import org.openxma.dsl.common.logging.LogUtil;

public class PathFixedReader extends Reader {

    /**
     * Fix URL-Encoded paths which may be contained in classpath if a file name
     * contains e.g. spaces.
     */
    @Override
    public void addPath(String path) {
        String decodedPath;
        try {
            decodedPath = java.net.URLDecoder.decode(path, "utf-8");
            if (!path.equals(decodedPath)) {
                LogUtil.info("URLDecoded path: " + decodedPath);
            }
        } catch (UnsupportedEncodingException e) {
            LogUtil.warn("Unable to URLDecode path: " + path);
            e.printStackTrace();
            decodedPath = path;
        }
        super.addPath(decodedPath);
    }

}
